{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module GDAL.GDALDataset.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import GDAL.GDALDataset.RawType
import GDAL.OGRLayer.RawType
import GDAL.GDALMajorObject.Interface

class (IGDALMajorObject a) => IGDALDataset a where
        getLayer :: () => a -> CInt -> IO OGRLayer
        
        getLayerCount :: () => a -> IO CInt

upcastGDALDataset ::
                  forall a . (FPtr a, IGDALDataset a) => a -> GDALDataset
upcastGDALDataset h
  = let fh = get_fptr h
        fh2 :: Ptr RawGDALDataset = castPtr fh
      in cast_fptr_to_obj fh2

downcastGDALDataset ::
                    forall a . (FPtr a, IGDALDataset a) => GDALDataset -> a
downcastGDALDataset h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
