{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module GDAL.OGRLinearRing.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import GDAL.OGRLinearRing.RawType
import GDAL.OGRLinearRing.FFI
import GDAL.OGRLinearRing.Interface
import GDAL.OGRLinearRing.Cast
import GDAL.OGRLinearRing.RawType
import GDAL.OGRLinearRing.Cast
import GDAL.OGRLinearRing.Interface
import GDAL.OGRPointIterator.RawType
import GDAL.OGRPointIterator.Cast
import GDAL.OGRPointIterator.Interface
import GDAL.OGRPolygon.RawType
import GDAL.OGRPolygon.Cast
import GDAL.OGRPolygon.Interface
import GDAL.OGRMultiPolygon.RawType
import GDAL.OGRMultiPolygon.Cast
import GDAL.OGRMultiPolygon.Interface
import GDAL.OGREnvelope.RawType
import GDAL.OGREnvelope.Cast
import GDAL.OGREnvelope.Interface
import GDAL.OGRPoint.RawType
import GDAL.OGRPoint.Cast
import GDAL.OGRPoint.Interface
import GDAL.OGRLineString.RawType
import GDAL.OGRLineString.Cast
import GDAL.OGRLineString.Interface
import GDAL.OGRSimpleCurve.RawType
import GDAL.OGRSimpleCurve.Cast
import GDAL.OGRSimpleCurve.Interface
import GDAL.OGRCurve.RawType
import GDAL.OGRCurve.Cast
import GDAL.OGRCurve.Interface
import GDAL.OGRGeometry.RawType
import GDAL.OGRGeometry.Cast
import GDAL.OGRGeometry.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => IOGRLinearRing (OGRLinearRing) where

instance () => IOGRLineString (OGRLinearRing) where

instance () => IOGRSimpleCurve (OGRLinearRing) where

instance () => IOGRCurve (OGRLinearRing) where
        getNumPoints = xform0 c_ogrlinearring_getnumpoints
        getPointIterator = xform0 c_ogrlinearring_getpointiterator

instance () => IOGRGeometry (OGRLinearRing) where
        getGeometryType = xform0 c_ogrlinearring_getgeometrytype
        getEnvelope = xform1 c_ogrlinearring_getenvelope
        intersects = xform1 c_ogrlinearring_intersects
        equals = xform1 c_ogrlinearring_equals
        disjoint = xform1 c_ogrlinearring_disjoint
        touches = xform1 c_ogrlinearring_touches
        crosses = xform1 c_ogrlinearring_crosses
        within = xform1 c_ogrlinearring_within
        contains = xform1 c_ogrlinearring_contains
        overlaps = xform1 c_ogrlinearring_overlaps
        boundary = xform0 c_ogrlinearring_boundary
        distance = xform1 c_ogrlinearring_distance
        convexHull = xform0 c_ogrlinearring_convexhull
        buffer = xform2 c_ogrlinearring_buffer
        intersection = xform1 c_ogrlinearring_intersection
        union = xform1 c_ogrlinearring_union
        unionCascaded = xform0 c_ogrlinearring_unioncascaded
        difference = xform1 c_ogrlinearring_difference
        symDifference = xform1 c_ogrlinearring_symdifference
        centroid = xform1 c_ogrlinearring_centroid
        simplify = xform1 c_ogrlinearring_simplify
        delaunayTriangulation
          = xform2 c_ogrlinearring_delaunaytriangulation
        polygonize = xform0 c_ogrlinearring_polygonize
        distance3D = xform1 c_ogrlinearring_distance3d

instance () => IDeletable (OGRLinearRing) where
        delete = xform0 c_ogrlinearring_delete
