{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module GDAL.OGRMultiSurface.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import GDAL.OGRMultiSurface.RawType
import GDAL.OGRMultiSurface.FFI
import GDAL.OGRMultiSurface.Interface
import GDAL.OGRMultiSurface.Cast
import GDAL.OGRMultiSurface.RawType
import GDAL.OGRMultiSurface.Cast
import GDAL.OGRMultiSurface.Interface
import GDAL.OGRPolygon.RawType
import GDAL.OGRPolygon.Cast
import GDAL.OGRPolygon.Interface
import GDAL.OGRMultiPolygon.RawType
import GDAL.OGRMultiPolygon.Cast
import GDAL.OGRMultiPolygon.Interface
import GDAL.OGREnvelope.RawType
import GDAL.OGREnvelope.Cast
import GDAL.OGREnvelope.Interface
import GDAL.OGRPoint.RawType
import GDAL.OGRPoint.Cast
import GDAL.OGRPoint.Interface
import GDAL.OGRGeometryCollection.RawType
import GDAL.OGRGeometryCollection.Cast
import GDAL.OGRGeometryCollection.Interface
import GDAL.OGRGeometry.RawType
import GDAL.OGRGeometry.Cast
import GDAL.OGRGeometry.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => IOGRMultiSurface (OGRMultiSurface) where

instance () => IOGRGeometryCollection (OGRMultiSurface) where

instance () => IOGRGeometry (OGRMultiSurface) where
        getGeometryType = xform0 c_ogrmultisurface_getgeometrytype
        getEnvelope = xform1 c_ogrmultisurface_getenvelope
        intersects = xform1 c_ogrmultisurface_intersects
        equals = xform1 c_ogrmultisurface_equals
        disjoint = xform1 c_ogrmultisurface_disjoint
        touches = xform1 c_ogrmultisurface_touches
        crosses = xform1 c_ogrmultisurface_crosses
        within = xform1 c_ogrmultisurface_within
        contains = xform1 c_ogrmultisurface_contains
        overlaps = xform1 c_ogrmultisurface_overlaps
        boundary = xform0 c_ogrmultisurface_boundary
        distance = xform1 c_ogrmultisurface_distance
        convexHull = xform0 c_ogrmultisurface_convexhull
        buffer = xform2 c_ogrmultisurface_buffer
        intersection = xform1 c_ogrmultisurface_intersection
        union = xform1 c_ogrmultisurface_union
        unionCascaded = xform0 c_ogrmultisurface_unioncascaded
        difference = xform1 c_ogrmultisurface_difference
        symDifference = xform1 c_ogrmultisurface_symdifference
        centroid = xform1 c_ogrmultisurface_centroid
        simplify = xform1 c_ogrmultisurface_simplify
        delaunayTriangulation
          = xform2 c_ogrmultisurface_delaunaytriangulation
        polygonize = xform0 c_ogrmultisurface_polygonize
        distance3D = xform1 c_ogrmultisurface_distance3d

instance () => IDeletable (OGRMultiSurface) where
        delete = xform0 c_ogrmultisurface_delete
