{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module GDAL.OGRPointIterator.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import GDAL.OGRPointIterator.RawType
import STD.Deletable.Interface
import GDAL.OGRPoint.Interface

class (IDeletable a) => IOGRPointIterator a where
        getNextPoint :: (IOGRPoint c0, FPtr c0) => a -> c0 -> IO CBool

upcastOGRPointIterator ::
                       forall a . (FPtr a, IOGRPointIterator a) => a -> OGRPointIterator
upcastOGRPointIterator h
  = let fh = get_fptr h
        fh2 :: Ptr RawOGRPointIterator = castPtr fh
      in cast_fptr_to_obj fh2

downcastOGRPointIterator ::
                         forall a . (FPtr a, IOGRPointIterator a) => OGRPointIterator -> a
downcastOGRPointIterator h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
