{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module GDAL.OGRSurface.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import GDAL.OGRSurface.RawType
import GDAL.OGRSurface.FFI
import GDAL.OGRSurface.Interface
import GDAL.OGRSurface.Cast
import GDAL.OGRSurface.RawType
import GDAL.OGRSurface.Cast
import GDAL.OGRSurface.Interface
import GDAL.OGRPolygon.RawType
import GDAL.OGRPolygon.Cast
import GDAL.OGRPolygon.Interface
import GDAL.OGRMultiPolygon.RawType
import GDAL.OGRMultiPolygon.Cast
import GDAL.OGRMultiPolygon.Interface
import GDAL.OGREnvelope.RawType
import GDAL.OGREnvelope.Cast
import GDAL.OGREnvelope.Interface
import GDAL.OGRPoint.RawType
import GDAL.OGRPoint.Cast
import GDAL.OGRPoint.Interface
import GDAL.OGRGeometry.RawType
import GDAL.OGRGeometry.Cast
import GDAL.OGRGeometry.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => IOGRSurface (OGRSurface) where

instance () => IOGRGeometry (OGRSurface) where
        getGeometryType = xform0 c_ogrsurface_getgeometrytype
        getEnvelope = xform1 c_ogrsurface_getenvelope
        intersects = xform1 c_ogrsurface_intersects
        equals = xform1 c_ogrsurface_equals
        disjoint = xform1 c_ogrsurface_disjoint
        touches = xform1 c_ogrsurface_touches
        crosses = xform1 c_ogrsurface_crosses
        within = xform1 c_ogrsurface_within
        contains = xform1 c_ogrsurface_contains
        overlaps = xform1 c_ogrsurface_overlaps
        boundary = xform0 c_ogrsurface_boundary
        distance = xform1 c_ogrsurface_distance
        convexHull = xform0 c_ogrsurface_convexhull
        buffer = xform2 c_ogrsurface_buffer
        intersection = xform1 c_ogrsurface_intersection
        union = xform1 c_ogrsurface_union
        unionCascaded = xform0 c_ogrsurface_unioncascaded
        difference = xform1 c_ogrsurface_difference
        symDifference = xform1 c_ogrsurface_symdifference
        centroid = xform1 c_ogrsurface_centroid
        simplify = xform1 c_ogrsurface_simplify
        delaunayTriangulation = xform2 c_ogrsurface_delaunaytriangulation
        polygonize = xform0 c_ogrsurface_polygonize
        distance3D = xform1 c_ogrsurface_distance3d

instance () => IDeletable (OGRSurface) where
        delete = xform0 c_ogrsurface_delete
