{-# LANGUAGE FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, InterruptibleFFI #-}
module GDAL.Ordinary (gDALAllRegister, gDALOpenEx) where
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import GDAL.GDALDataset.RawType
import GDAL.GDALDataset.Cast
import GDAL.GDALDataset.Interface

foreign import ccall interruptible
               "hgdalTopLevel.h TopLevel_GDALAllRegister" c_gdalallregister ::
               IO ()

foreign import ccall interruptible
               "hgdalTopLevel.h TopLevel_GDALOpenEx" c_gdalopenex ::
               CString ->
                 CUInt ->
                   Ptr CString ->
                     Ptr CString -> Ptr CString -> IO (Ptr RawGDALDataset)

gDALAllRegister :: () => IO ()
gDALAllRegister = xformnull c_gdalallregister

gDALOpenEx ::
             (Castable c0 CString) =>
             c0 ->
               CUInt ->
                 Ptr CString -> Ptr CString -> Ptr CString -> IO GDALDataset
gDALOpenEx = xform4 c_gdalopenex
